# Dendriform.jl Library

```@contents
```

## Index

```@index
```

## Dendriform Types

```@docs
PBTree
```

```@docs
Grove
```

```@docs
GroveBin
```

```@docs
Dendriform.BaseTree
```

## Dendriform Operators

```@docs
∪
```

### Branching

```@docs
graft
```

```@docs
∨
```

```@docs
left
```

```@docs
right
```

### Partial Ordering

```@docs
posetnext
```

```@docs
posetprev
```

```@docs
⋖
```

```@docs
⋗
```

```@docs
<
```

```@docs
>
```

```@docs
≤
```

```@docs
≥
```

```@docs
between
```

```@docs
⊴
```



### Dialgebra Arithmetic

```@docs
over
```

```@docs
under
```

```@docs
/
```

```@docs
\
```

```@docs
dashv
```

```@docs
vdash
```

```@docs
⊣
```

```@docs
⊢
```

```@docs
+
```

```@docs
*
```

## Dendriform Morphisms

```@docs
σ
```

### Consistency Checks

```@docs
Dendriform.LeftInherited
```

```@docs
Dendriform.RightInherited
```

```@docs
Dendriform.PrimitiveTree
```

```@docs
treecheck
```

```@docs
grovecheck
```

```@docs
Dendriform.GroveError
```

### Index Data

```@docs
treeindex
```

```@docs
groveindex
```

```@docs
grovebit
```

### Transformations

```@docs
Dendriform.TreeBase
```

```@docs
Dendriform.TreeInteger
```

```@docs
Dendriform.TreeRational
```

## Tools & Options

```@docs
grovedisplay
```

```@docs
grovesort
```

```@docs
treeshift
```
